Bug 155895 - CONFIG_SERIAL_8250=y prevents CONFIG_SERIAL_PMACZILOG=m from working on pmac
CONFIG_SERIAL_8250=y prevents CONFIG_SERIAL_PMACZILOG=m from working on pmac
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
5
powerpc Linux
medium Severity medium
: ---
: ---
Assigned To: David Woodhouse
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-04-25 10:52 EDT by Roger Blofeld
Modified: 2008-03-10 19:34 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-03-10 19:34:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Roger Blofeld 2005-04-25 10:52:31 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-us) AppleWebKit/312.1 (KHTML, like Gecko) Safari/312

Description of problem:
On pmac 8250 conflicts with pmac_zilog.ko, so having it built into the kernel means pmac users cannot 
use their serial ports. Shouldn't the pmac default be have 8250 unused or as a module?

Looking at the current cvs, CONFIG_SERIAL_8250 is defined in configs/config-generic, which gets 
combined with config-ppc-generic and config-ppc-pmac[-smp] to create kernel-2.6.11-ppc[-
smp].config. Is it possible to override the definition from config-generic in config-ppc-pmac* ?

Or is there some other way to get around the built-in 8250?

Version-Release number of selected component (if applicable):
kernel-smp-2.6.11-1.1261_FC4

How reproducible:
Always

Steps to Reproduce:
1. modprobe pmac_zilog
2.
3.
  

Actual Results:  FATAL: Error inserting pmac_zilog (/lib/modules/2.6.11-1.1261_FC4smp/kernel/drivers/serial/
pmac_zilog.ko): Device or resource busy

Apr 25 09:50:18 bert kernel: pmac_zilog: 0.6 (Benjamin Herrenschmidt <benh@kernel.crashing.org>)
Apr 25 09:50:18 bert kernel: pmac_zilog: i2c-modem detected, id: 1
Apr 25 09:50:18 bert kernel: pmac_zilog: Error registering serial device, disabling pmac_zilog.
Apr 25 09:50:18 bert kernel: pmac_zilog: Did another serial driver already claim the minors?


Expected Results:  normal pmac_zilog load

Additional info:

pmac dual g4 450
Comment 1 Dave Jones 2006-10-16 13:32:24 EDT
A new kernel update has been released (Version: 2.6.18-1.2200.fc5)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

In the last few updates, some users upgrading from FC4->FC5
have reported that installing a kernel update has left their
systems unbootable. If you have been affected by this problem
please check you only have one version of device-mapper & lvm2
installed.  See bug 207474 for further details.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

If this bug has been fixed, but you are now experiencing a different
problem, please file a separate bug for the new problem.

Thank you.
Comment 2 Roger Blofeld 2006-10-18 22:54:51 EDT
Problem still exists:

"modprobe pmac_zilog" yields

FATAL: Error inserting pmac_zilog
(/lib/modules/2.6.18-1.2207smp/kernel/drivers/serial/pmac_zilog.ko): Device or
resource busy

and in /var/log/messages:

Oct 18 21:52:22 bert kernel: pmac_zilog: 0.6 (Benjamin Herrenschmidt
<benh@kernel.crashing.org>)
Oct 18 21:52:22 bert kernel: pmac_zilog: i2c-modem detected, id: 1
Oct 18 21:52:22 bert kernel: pmac_zilog: Error registering serial device,
disabling pmac_zilog.
Oct 18 21:52:22 bert kernel: pmac_zilog: Did another serial driver already claim
the minors?

Comment 3 Joseph Sacco 2006-12-01 10:13:16 EST
Problem persists in 2.6.18-1.2849.fc6smp

pmac_zilog: 0.6 (Benjamin Herrenschmidt <benh@kernel.crashing.org>)
pmac_zilog: i2c-modem detected, id: 1
pmac_zilog: Error registering serial device, disabling pmac_zilog.
pmac_zilog: Did another serial driver already claim the minors?


-Joseph
Comment 4 David Woodhouse 2006-12-01 10:27:37 EST
Yeah, we need LANANA to assign device numbers for pmac_zilog rather than
continuing to abuse the device numbers which belong to 8250.

What's the maximum number of such devices which could be found in a machine?
Comment 5 Joseph Sacco 2006-12-01 10:35:58 EST
Four...

From pmac_zilog.h:  #define MAX_ZS_PORTS    4


-Joseph
Comment 6 David Woodhouse 2006-12-01 10:43:55 EST
Ok, I've mailed device@lanana.org to assign four minors.
Comment 7 David Woodhouse 2007-03-31 19:05:17 EDT
After a reminder, I finally got a response. Should be fixed in the next rawhide
build (2.6.20-1.3037). Once confirmed there we'll backport the fix to FC6.
Comment 8 Joseph Sacco 2007-03-31 19:47:27 EDT
Awesome!!! Thanks, David.  I will test and confirm when available.

-Joseph
Comment 9 David Woodhouse 2007-03-31 19:59:41 EDT
I lied; 3038 not 3037.
Comment 10 Joseph Sacco 2007-04-12 11:38:07 EDT
David,

Looks like your fix has gone walkabout. As of kernel version 3059, pmac_zilog
support is still borked.

-Joseph
Comment 11 David Woodhouse 2007-04-13 08:11:59 EDT
Looks like it's still there to me, and seems to work on my PowerBook in the
latest kernel I tried. What's the failure mode for you? Is the module loaded?
Comment 12 Joseph Sacco 2007-04-13 09:38:30 EDT
David,

"We" are OK now.

The Problem
-----------
minicom was unable to connect to the internal modem configured to use /dev/ttyS0.

Analysis:
--------
pmac_zilog kernel module is loaded, but is unused:

   pmac_zilog             22300  0


Watching /var/log/messages, while reloading the module reveals the source of the
problem:

Apr 13 09:16:58 plantain kernel: pmac_zilog: 0.6 (Benjamin Herrenschmidt
<benh@kernel.crashing.org>)
Apr 13 09:16:58 plantain kernel: pmac_zilog: i2c-modem detected, id: 1
Apr 13 09:16:58 plantain kernel: ttyPZ0 at MMIO 0x80013020 (irq = 22) is a
Z85c30 ESCC - Internal modem
Apr 13 09:16:58 plantain kernel: ttyPZ1 at MMIO 0x80013000 (irq = 50) is a
Z85c30 ESCC - Serial port

==> The pmac_zlog ports are named ttyPZ0 and ttyPZ1.

reconfigure minicom to use ttyPZ0:
* the modem now responds
* kernel module is used while minicom is running:

    pmac_zilog             22300  2


You can mark this bug closed and retro-fit the changes into FC6.


Thank you, David.


-Joseph
Comment 13 petrosyan 2008-03-10 19:34:29 EDT
Closing this bug as requested in the previous comment.

Note You need to log in before you can comment on or make changes to this bug.